/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define NWM_SERVERNAME	"Null Webmail / 0.7.1"

/*
 * HAVE_CONFIG specifies the file name of a config file which can be used to
 * override any and all options specified in this file that are prefixed with
 * 'CONFIG_'.
 */
#define HAVE_CONFIG	"webmail.cfg"

/*
 * If HAVE_SQL is defined, SQL support for WinODBC, MySQL, PgSQL, and SQLite
 * will be added to the webmail cgi.  SQL support will almost definitely NOT
 * work if the cgi is statically linked.
 *
 * Nothing in the cgi uses this yet, so don't even think of enabling this
 * unless you're a programmer with a feature to add.
 */
//	#define HAVE_SQL
#ifdef HAVE_SQL
	#define CONFIG_SQL_TYPE		"MYSQL"
	#define CONFIG_SQL_HOST		"localhost"
	#define CONFIG_SQL_PORT		3306
	#define CONFIG_SQL_USER		"nobody"
	#define CONFIG_SQL_PASS		""
	#define CONFIG_SQL_DB		"nullwebmail"
#endif

/*
 * CONFIG_POP3_HOST and CONFIG_SMTP_HOST really should be changed to reflect
 * the fully qualified domain names of the mail servers.  The port settings
 * typically shouldn't need to be changed.
 */
#define CONFIG_POP3_HOST	"localhost"
#define CONFIG_SMTP_HOST	"localhost"
#define CONFIG_IMAP_PORT	143
#define CONFIG_POP3_PORT	110
#define CONFIG_SMTP_PORT	25

/*
 * You MUST support either POP3, IMAP, or both, otherwise the CGI doesn't work.
 * IMAP support is still highly experimental right now, so I recommend against
 * using it.
 */
//	#define CONFIG_SUPPORT_IMAP
#define CONFIG_SUPPORT_POP3

/*
 * CONFIG_APPEND_ADDRESS will let you override the hostname part of return
 * e-mail addresses.  If you don't need it, then don't use it.  You probably
 * will want to use this if the return address domain name is more than two
 * levels.  If the username is the full return address (ie, virtual mail
 * systems), you may want to define CONFIG_APPEND_ADDRESS as a blank string.
 * If you don't use CONFIG_APPEND_ADDRESS, your return address will be the top
 * two levels of the pop3 host's name.
 */
//	#define CONFIG_APPEND_ADDRESS "@here.somewhere.com"

/*
 * CONFIG_ALLOW_USERFROM will allow users to define their own From: field data.
 */
//	#define CONFIG_ALLOW_USERFROM

/*
 * If #defined, CONFIG_NO_USER_HOSTS will remove the user's ability to choose
 * their own host names.  Be sure to set CONFIG_POP3_HOST and CONFIG_SMTP_HOST
 * correctly if you choose to use this option.
 */
#define CONFIG_ALLOW_USERHOSTS

/*
 * CONFIG_SMTP_AUTH enables plain auth with smtp servers using the pop3/imap
 * username and password.
 */
//	#define CONFIG_SMTP_AUTH

/*
 * CONFIG_BASE_IMAGE_URL tells the cgi where the images are.  CONFIG_STYLESHEET
 * can be used to point to any CSS file you may want to use.
 */
#define CONFIG_BASE_IMAGE_URL	"/webmail/"
#define CONFIG_STYLESHEET	"/webmail/style.css"

/*
 * These colour #defines allow easy customization of many of the colours used
 * in the CGI.  Some of these colours may be overridded if a stylesheet is in
 * use (i.e. CONFIG_COLOUR_TRIM and CONFIG_COLOUR_TRIMTEXT).
 */
#define CONFIG_COLOUR_BODYBG		"#FFFFFF"
#define CONFIG_COLOUR_EDITFORM		"#E0E0E0"
#define CONFIG_COLOUR_FTEXT		"#F0F0F0"
#define CONFIG_COLOUR_LINKS		"#0000FF"
#define CONFIG_COLOUR_MLISTEVEN		"#E0E0E0"
#define CONFIG_COLOUR_MLISTODD		"#D0D0D0"
#define CONFIG_COLOUR_MLISTNEW		"#B0B0FF"
#define CONFIG_COLOUR_TRIM		"#000050"
#define CONFIG_COLOUR_TRIMTEXT		"#FFFFFF"

/*
 * If your pop3 server supports Status: headers, enable the following line to
 * allow new messages to be marked with a different colour.
 */
//	#define CONFIG_POP_STATUS

/*
 * If there are more than CONFIG_MAX_LIST_SIZE messages, the message list will
 * be broken up into multiple pages.
 */
#define CONFIG_MAX_LIST_SIZE	50

/*
 * This setting is not an inactivity timer, but instead limits the absolute
 * maximum time in seconds that the cgi is allowed to run.
 */
#define CONFIG_MAX_RUNTIME	600

/*
 * This setting defines the absolute maximum number of recipients allowed per
 * outgoing message.
 */
#define CONFIG_MAX_RECIPIENTS	25

/*
 * CONFIG_MAX_POSTSIZE limits the total size of allowable POSTS, and as a
 * result can be used to control the maximum size of a message and/or
 * attachments.
 */
#define CONFIG_MAX_POSTSIZE	33554432 /* 32 MB limit for allowed POST sizes */

#define CONFIG_RAW_MESSAGES
#define CONFIG_USE_FRAMES
#define CONFIG_USE_SYSLOG

/*
 * If you want to change the language, uncomment the appropriate strings header
 * file here.  #include one, and only one strings file.
 */
//	#include "i18n/strings-ca.h	// Catalan
//	#include "i18n/strings-cz.h"	// Czech
//	#include "i18n/strings-da.h"	// Danish
//	#include "i18n/strings-de.h"	// German
//	#include "i18n/strings-ee.h"	// Estonian
//	#include "i18n/strings-el.h"	// Greek
#include "i18n/strings-en.h"		// English
//	#include "i18n/strings-es.h"	// Spanish
//	#include "i18n/strings-fi.h"	// Finnish
//	#include "i18n/strings-fr.h"	// French
//	#include "i18n/strings-gz.h"	// Galician
//	#include "i18n/strings-hu.h"	// Hungarian
//	#include "i18n/strings-it.h"	// Italian
//	#include "i18n/strings-ja.h"	// Japanese
//	#include "i18n/strings-kr.h"	// Korean
//	#include "i18n/strings-mk.h"	// Macedonian
//	#include "i18n/strings-nl.h"	// Netherland
//	#include "i18n/strings-no.h"	// Norwegian
//	#include "i18n/strings-pl.h"	// Polish
//	#include "i18n/strings-pt.h"	// Portugese (Brazilian)
//	#include "i18n/strings-ro.h"	// Romanian
//	#include "i18n/strings-ru.h"	// Russian KOI-8
//	#include "i18n/strings-sk.h"	// Slovak
//	#include "i18n/strings-sv.h"	// Swedish
