/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

int config_read()
{
	FILE *fp;
	char line[512];
	char *pVar;
	char *pVal;
	int i;

	/* define default values */
	memset((char *)&config, 0, sizeof(config));
#ifdef HAVE_SQL
	snprintf(config.sql_type,  sizeof(config.sql_type)-1,  "%s", CONFIG_SQL_TYPE);
	snprintf(config.sql_host,  sizeof(config.sql_host)-1,  "%s", CONFIG_SQL_HOST);
	snprintf(config.sql_port,  sizeof(config.sql_port)-1,  "%d", CONFIG_SQL_PORT);
	snprintf(config.sql_user,  sizeof(config.sql_user)-1,  "%s", CONFIG_SQL_USER);
	snprintf(config.sql_pass,  sizeof(config.sql_pass)-1,  "%s", CONFIG_SQL_PASS);
	snprintf(config.sql_db,    sizeof(config.sql_db)-1,    "%s", CONFIG_SQL_DB);
#endif
	snprintf(config.pop3_host, sizeof(config.pop3_host)-1, "%s", CONFIG_POP3_HOST);
	snprintf(config.smtp_host, sizeof(config.smtp_host)-1, "%s", CONFIG_SMTP_HOST);
	config.imap_port=CONFIG_IMAP_PORT;
	config.pop3_port=CONFIG_POP3_PORT;
	config.smtp_port=CONFIG_SMTP_PORT;
#ifdef CONFIG_SUPPORT_IMAP
	config.support_imap='y';
#else
	config.support_imap='n';
#endif
#ifdef CONFIG_SUPPORT_POP3
	config.support_pop3='y';
#else
	config.support_pop3='n';
#endif
#ifdef CONFIG_APPEND_ADDRESS
	config.use_append_address='y';
	snprintf(config.append_address, sizeof(config.append_address)-1, "%s", CONFIG_APPEND_ADDRESS);
#else
	config.use_append_address='n';
#endif
#ifdef CONFIG_ALLOW_USERFROM
	config.allow_userfrom='y';
#else
	config.allow_userfrom='n';
#endif
#ifdef CONFIG_ALLOW_USERHOSTS
	config.allow_userhosts='y';
#else
	config.allow_userhosts='n';
#endif
#ifdef CONFIG_SMTP_AUTH
	config.smtp_auth='y';
#else
	config.smtp_auth='n';
#endif
#ifdef CONFIG_BASE_IMAGE_URL
	snprintf(config.base_image_url, sizeof(config.base_image_url)-1, "%s", CONFIG_BASE_IMAGE_URL);
#endif
#ifdef CONFIG_STYLESHEET
	snprintf(config.stylesheet, sizeof(config.stylesheet)-1, "%s", CONFIG_STYLESHEET);
#endif
	snprintf(config.colour_bodybg, sizeof(config.colour_bodybg)-1, "%s", CONFIG_COLOUR_BODYBG);
	snprintf(config.colour_editform, sizeof(config.colour_editform)-1, "%s", CONFIG_COLOUR_EDITFORM);
	snprintf(config.colour_ftext, sizeof(config.colour_ftext)-1, "%s", CONFIG_COLOUR_FTEXT);
	snprintf(config.colour_links, sizeof(config.colour_links)-1, "%s", CONFIG_COLOUR_LINKS);
	snprintf(config.colour_mlisteven, sizeof(config.colour_mlisteven)-1, "%s", CONFIG_COLOUR_MLISTEVEN);
	snprintf(config.colour_mlistodd, sizeof(config.colour_mlistodd)-1, "%s", CONFIG_COLOUR_MLISTODD);
	snprintf(config.colour_mlistnew, sizeof(config.colour_mlistnew)-1, "%s", CONFIG_COLOUR_MLISTNEW);
	snprintf(config.colour_trim, sizeof(config.colour_trim)-1, "%s", CONFIG_COLOUR_TRIM);
	snprintf(config.colour_trimtext, sizeof(config.colour_trimtext)-1, "%s", CONFIG_COLOUR_TRIMTEXT);
#ifdef CONFIG_POP_STATUS
	config.pop_status='y';
#else
	config.pop_status='n';
#endif
	config.max_list_size=CONFIG_MAX_LIST_SIZE;
	config.max_runtime=CONFIG_MAX_RUNTIME;
	config.max_postsize=CONFIG_MAX_POSTSIZE;
	config.max_recipients=CONFIG_MAX_RECIPIENTS;
#ifdef CONFIG_RAW_MESSAGES
	config.raw_messages='y';
#else
	config.raw_messages='n';
#endif
#ifdef CONFIG_USE_FRAMES
	config.use_frames='y';
#else
	config.use_frames='n';
#endif
#ifdef CONFIG_USE_SYSLOG
	config.use_syslog='y';
#else
	config.use_syslog='n';
#endif
	if ((fp=fopen("webmail.cfg", "r"))==NULL) {
		return 0;
	}
	while (1) {
		memset(line, 0, sizeof(line));
		if (fgets(line, sizeof(line)-1, fp)==NULL) break;
		while (1) {
			i=strlen(line);
			if (i<1) break;
			if ((line[i-1]=='\r')||(line[i-1]=='\n')) { line[i-1]='\0'; continue; }
			break;
		};
		if (isalpha(line[0])) {
			pVar=line;
			pVal=line;
			while ((*pVal!='=')&&((char *)&pVal+1!='\0')) pVal++;
			*pVal='\0';
			pVal++;
			while (*pVar==' ') pVar++;
			while (pVar[strlen(pVar)-1]==' ') pVar[strlen(pVar)-1]='\0';
			while (*pVal==' ') pVal++;
			while (pVal[strlen(pVal)-1]==' ') pVal[strlen(pVal)-1]='\0';
			while (*pVal=='"') pVal++;
			while (pVal[strlen(pVal)-1]=='"') pVal[strlen(pVal)-1]='\0';
			if (strcmp(pVar, "POP3_HOST")==0) {
				strncpy(config.pop3_host, pVal, sizeof(config.pop3_host)-1);
			} else if (strcmp(pVar, "SMTP_HOST")==0) {
				strncpy(config.smtp_host, pVal, sizeof(config.smtp_host)-1);
			} else if (strcmp(pVar, "IMAP_PORT")==0) {
				config.imap_port=atoi(pVal);
			} else if (strcmp(pVar, "POP3_PORT")==0) {
				config.pop3_port=atoi(pVal);
			} else if (strcmp(pVar, "SMTP_PORT")==0) {
				config.smtp_port=atoi(pVal);
			} else if (strcmp(pVar, "SUPPORT_IMAP")==0) {
				config.support_imap=tolower(pVal[0]);
			} else if (strcmp(pVar, "SUPPORT_POP3")==0) {
				config.support_pop3=tolower(pVal[0]);
			} else if (strcmp(pVar, "USE_APPEND_ADDRESS")==0) {
				config.use_append_address=tolower(pVal[0]);
			} else if (strcmp(pVar, "APPEND_ADDRESS")==0) {
				strncpy(config.append_address, pVal, sizeof(config.append_address)-1);
			} else if (strcmp(pVar, "ALLOW_USERFROM")==0) {
				config.allow_userfrom=tolower(pVal[0]);
			} else if (strcmp(pVar, "ALLOW_USERHOSTS")==0) {
				config.allow_userhosts=tolower(pVal[0]);
			} else if (strcmp(pVar, "SMTP_AUTH")==0) {
				config.smtp_auth=tolower(pVal[0]);
			} else if (strcmp(pVar, "BASE_IMAGE_URL")==0) {
				strncpy(config.base_image_url, pVal, sizeof(config.base_image_url)-1);
			} else if (strcmp(pVar, "STYLESHEET")==0) {
				strncpy(config.stylesheet, pVal, sizeof(config.stylesheet)-1);
			} else if (strcmp(pVar, "COLOUR_BODYBG")==0) {
				strncpy(config.colour_bodybg, pVal, sizeof(config.colour_bodybg)-1);
			} else if (strcmp(pVar, "COLOUR_EDITFORM")==0) {
				strncpy(config.colour_editform, pVal, sizeof(config.colour_editform)-1);
			} else if (strcmp(pVar, "COLOUR_FTEXT")==0) {
				strncpy(config.colour_ftext, pVal, sizeof(config.colour_ftext)-1);
			} else if (strcmp(pVar, "COLOUR_LINKS")==0) {
				strncpy(config.colour_links, pVal, sizeof(config.colour_links)-1);
			} else if (strcmp(pVar, "COLOUR_MLISTEVEN")==0) {
				strncpy(config.colour_mlisteven, pVal, sizeof(config.colour_mlisteven)-1);
			} else if (strcmp(pVar, "COLOUR_MLISTODD")==0) {
				strncpy(config.colour_mlistodd, pVal, sizeof(config.colour_mlistodd)-1);
			} else if (strcmp(pVar, "COLOUR_MLISTNEW")==0) {
				strncpy(config.colour_mlistnew, pVal, sizeof(config.colour_mlistnew)-1);
			} else if (strcmp(pVar, "COLOUR_TRIM")==0) {
				strncpy(config.colour_trim, pVal, sizeof(config.colour_trim)-1);
			} else if (strcmp(pVar, "COLOUR_TRIMTEXT")==0) {
				strncpy(config.colour_trimtext, pVal, sizeof(config.colour_trimtext)-1);
			} else if (strcmp(pVar, "POP_STATUS")==0) {
				config.pop_status=tolower(pVal[0]);
			} else if (strcmp(pVar, "MAX_LIST_SIZE")==0) {
				config.max_list_size=atoi(pVal);
			} else if (strcmp(pVar, "MAX_RUNTIME")==0) {
				config.max_runtime=atoi(pVal);
			} else if (strcmp(pVar, "MAX_POSTSIZE")==0) {
				config.max_postsize=atoi(pVal);
			} else if (strcmp(pVar, "MAX_RECIPIENTS")==0) {
				config.max_recipients=atoi(pVal);
			} else if (strcmp(pVar, "RAW_MESSAGES")==0) {
				config.raw_messages=tolower(pVal[0]);
			} else if (strcmp(pVar, "USE_FRAMES")==0) {
				config.use_frames=tolower(pVal[0]);
			} else if (strcmp(pVar, "USE_SYSLOG")==0) {
				config.use_syslog=tolower(pVal[0]);
#ifdef HAVE_SQL
			} else if (strcmp(pVar, "SQL_TYPE")==0) {
				strncpy(config.sql_type, pVal, sizeof(config.sql_type)-1);
			} else if (strcmp(pVar, "SQL_HOST")==0) {
				strncpy(config.sql_host, pVal, sizeof(config.sql_host)-1);
			} else if (strcmp(pVar, "SQL_PORT")==0) {
				strncpy(config.sql_port, pVal, sizeof(config.sql_port)-1);
			} else if (strcmp(pVar, "SQL_USER")==0) {
				strncpy(config.sql_user, pVal, sizeof(config.sql_user)-1);
			} else if (strcmp(pVar, "SQL_PASS")==0) {
				strncpy(config.sql_pass, pVal, sizeof(config.sql_pass)-1);
			} else if (strcmp(pVar, "SQL_DB")==0) {
				strncpy(config.sql_db, pVal, sizeof(config.sql_db)-1);
#endif
			}
			*pVal='\0';
			*pVar='\0';
		}
	}
	fclose(fp);
	return 0;
}
