/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

config_struct config;
request_struct request;
#ifdef HAVE_SQL
SQLREPLY sqlreply[MAX_QUERIES];
int sql_is_connected;
#endif
int  connected;
char wmusername[64];
char wmpassword[64];
char wmservertype[6];
char wmpop3server[64];
char wmsmtpserver[64];
char wmaddress[128];
int  wmsocket;
int  wmimapidx;
int  wmimapmread;
int  wmimapmsize;

int main(int argc, char *argv[])
{
	char location[255];

	if (getenv("REQUEST_METHOD")==NULL) {
		printf("This program must be run as a CGI.\r\n");
		exit(0);
	}
	config_read();
	setsigs();
	setvbuf(stdout, NULL, _IONBF, 0);
#ifdef WIN32
	_setmode(_fileno(stdin), _O_BINARY);
	_setmode(_fileno(stdout), _O_BINARY);
#else
	if (config.use_syslog=='y') {
		openlog("nullwebmail", LOG_PID, LOG_MAIL);
	}
#endif
	connected=0;
	cgi_readenv();
	if (config.use_frames=='y') {
		if (strncmp(request.RequestURI, "/topframe", 9)==0) {
			printtopframe();
			fflush(stdout);
			return 0;
		} else if (strncmp(request.RequestURI, "/leftframe", 10)==0) {
			printleftframe();
			fflush(stdout);
			return 0;
		}
	}
	if (wmcookieget()!=0) {
		if (wmcookieset()==0) {
			memset(location, 0, sizeof(location));
			printf("Status: 302 Found\r\n");
			printf("Location: %s/\r\n", request.ScriptName);
			printf("Cache-Control: no-cache; must-revalidate\r\n");
			printf("Pragma: no-cache\r\n");
			printf("Content-Type: text/html\r\n");
			printf("\r\n");
			printf("<HTML><BODY>\r\n");
			printf("<CENTER>The requested resource can be found at <A HREF=%s/>%s/</A>.</CENTER>\r\n", request.ScriptName, request.ScriptName);
			printf("<SCRIPT LANGUAGE=JavaScript>\r\n<!--\r\nlocation.replace('%s/');\r\n// -->\r\n</SCRIPT>\r\n", request.ScriptName);
			printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"1; URL='%s/'\">\r\n", request.ScriptName);
			printf("</BODY></HTML>\r\n");
			return 0;
		} else {
			send_header(0, "1", "text/html", -1, -1);
			printlogin();
		}
		fflush(stdout);
		return 0;
	}
	if (strcmp(request.RequestURI, "/")==0) {
		send_header(0, "1", "text/html", -1, -1);
		if (config.use_frames=='y') {
			printframeset();
		} else {
			webmaillist();
		}
	} else if (strncmp(request.RequestURI, "/maildelete", 11)==0) {
		send_header(0, "1", "text/html", -1, -1);
		webmaildelete();
	} else if (strncmp(request.RequestURI, "/mailfile", 9)==0) {
		webmailfiledl();
	} else if (strncmp(request.RequestURI, "/maillist", 9)==0) {
		send_header(0, "1", "text/html", -1, -1);
		webmaillist();
	} else if (strncmp(request.RequestURI, "/mailraw", 8)==0) {
		send_header(0, "1", "text/plain", -1, -1);
		webmailraw();
	} else if (strncmp(request.RequestURI, "/mailread", 9)==0) {
		send_header(0, "1", "text/html", -1, -1);
		webmailread();
	} else if (strncmp(request.RequestURI, "/mailquit", 9)==0) {
		wmcookiekill();
		send_header(0, "1", "text/html", -1, -1);
		printlogout();
	} else if (strncmp(request.RequestURI, "/mailsend", 9)==0) {
		send_header(0, "1", "text/html", -1, -1);
		webmailsend();
	} else if (strncmp(request.RequestURI, "/mailwrite", 10)==0) {
		send_header(0, "1", "text/html", -1, -1);
		webmailwrite();
	} else {
		send_header(0, "1", "text/html", -1, -1);
		printf("Unknown command");
	}
	fflush(stdout);
	if (request.PostData!=NULL) {
		free(request.PostData);
	}
#ifndef WIN32
	if (config.use_syslog=='y') {
		closelog();
	}
#endif
	return 0;
}
