/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

static char filename[20][100];
static int numfiles=0;

int webmailheader(wmheader *header)
{
	char inbuffer[1024];
	char *prevheader=NULL;
	char *ptemp;
	int prevheadersize=0;

	header->status='n';
	for (;;) {
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
		striprn(inbuffer);
		if (strcmp(inbuffer, "")==0) break;
		if (strncasecmp(inbuffer, "Reply-To:", 9)==0) {
			prevheader=header->ReplyTo;
			prevheadersize=sizeof(header->ReplyTo);
			ptemp=inbuffer+9;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->ReplyTo, ptemp, sizeof(header->ReplyTo)-1);
		} else if (strncasecmp(inbuffer, "From:", 5)==0) {
			prevheader=header->From;
			prevheadersize=sizeof(header->From);
			ptemp=inbuffer+5;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->From, ptemp, sizeof(header->From)-1);
		} else if (strncasecmp(inbuffer, "To:", 3)==0) {
			prevheader=header->To;
			prevheadersize=sizeof(header->To);
			ptemp=inbuffer+3;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->To, ptemp, sizeof(header->To)-1);
		} else if (strncasecmp(inbuffer, "CC:", 3)==0) {
			prevheader=header->CC;
			prevheadersize=sizeof(header->CC);
			ptemp=inbuffer+3;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->CC, ptemp, sizeof(header->CC)-1);
		} else if (strncasecmp(inbuffer, "Subject:", 8)==0) {
			prevheader=header->Subject;
			prevheadersize=sizeof(header->Subject);
			ptemp=inbuffer+8;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->Subject, ptemp, sizeof(header->Subject)-1);
		} else if (strncasecmp(inbuffer, "Date:", 5)==0) {
			prevheader=header->Date;
			prevheadersize=sizeof(header->Date);
			ptemp=inbuffer+5;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->Date, ptemp, sizeof(header->Date)-1);
		} else if (strncasecmp(inbuffer, "Content-Type:", 13)==0) {
			prevheader=header->contenttype;
			prevheadersize=sizeof(header->contenttype);
			ptemp=inbuffer+13;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->contenttype, ptemp, sizeof(header->contenttype)-1);
		} else if (strncasecmp(inbuffer, "Content-Transfer-Encoding: ", 26)==0) {
			prevheader=header->encoding;
			prevheadersize=sizeof(header->encoding);
			ptemp=inbuffer+26;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			strncpy(header->encoding, ptemp, sizeof(header->encoding)-1);
		} else if (strncasecmp(inbuffer, "Status:", 7)==0) {
			prevheader=NULL;
			prevheadersize=sizeof(header->status);
			ptemp=inbuffer+7;
			while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
			if (strchr(ptemp, 'R')!=NULL) header->status='r';
		} else if ((inbuffer[0]==' ')||(inbuffer[0]=='\t')) {
			if (prevheader==NULL) continue;
			strncat(prevheader, inbuffer, prevheadersize-strlen(prevheader)-1);
		} else {
			prevheader=NULL;
			prevheadersize=0;
		}
	}
	if ((ptemp=strcasestr(header->contenttype, "boundary="))!=NULL) {
		ptemp+=9;
		if (*ptemp==' ') ptemp++;
		if (*ptemp=='\"') ptemp++;
		snprintf(header->boundary, sizeof(header->boundary)-1, "--");
		while ((*ptemp)&&(*ptemp!='\"')&&(strlen(header->boundary)<sizeof(header->boundary)-1)) {
			header->boundary[strlen(header->boundary)]=*ptemp;
			ptemp++;
		}
	}
	if (strlen(header->ReplyTo)==0) {
		ptemp=header->From;
		while ((*ptemp)&&(*ptemp!='<')) ptemp++;
		if (*ptemp=='<') ptemp++;
		while ((*ptemp)&&(*ptemp!='>')&&(strlen(header->ReplyTo)<sizeof(header->ReplyTo)-1)) {
			header->ReplyTo[strlen(header->ReplyTo)]=*ptemp;
			ptemp++;
		}
		if (strlen(header->ReplyTo)==0) {
			strncpy(header->ReplyTo, header->From, sizeof(header->ReplyTo)-1);
		}
	} else {
		ptemp=header->ReplyTo;
		while ((*ptemp)&&(*ptemp!='<')) ptemp++;
		if (*ptemp=='<') {
			ptemp++;
			memmove(header->ReplyTo, ptemp, strlen(ptemp)+1);
			while ((*ptemp)&&(*ptemp!='>')) ptemp++;
			if (*ptemp=='>') *ptemp='\0';
		}
	}
	if (strlen(header->From)==0) strcpy(header->From, "(No Sender Name)");
	if (strlen(header->Subject)==0) strcpy(header->Subject, "(No Subject)");
	if (strlen(header->Date)==0) strcpy(header->Date, "(No Date)");
	return 0;
}

static int webmailfiledl_r(char *boundary, char *filename, short int depth)
{
	char inbuffer[1024];
	char fnamebuf[512];
	char cdisp[128];
	char cencode[100];
	char cfile[256];
	char ctype[200];
	char cbound[100];
	char tbound[100];
	char *ptemp;
	int head=0;
	char *prevheader;
	int prevheadersize=0;

	depth++;
	for (;;) {
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
		if (is_msg_end(inbuffer)) break;
		if (strcasestr(inbuffer, boundary)!=NULL) {
			head=1;
			break;
		}
	}
	memset(cdisp, 0, sizeof(cdisp));
	memset(ctype, 0, sizeof(ctype));
	memset(cbound, 0, sizeof(cbound));
	memset(tbound, 0, sizeof(tbound));
	snprintf(tbound, sizeof(tbound)-1, "%s--", boundary);
	for (;;) {
		if (is_msg_end(inbuffer)) break;
		if ((depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return 0;
		if (head) {
			memset(cfile, 0, sizeof(cfile));
			memset(cdisp, 0, sizeof(cdisp));
			memset(ctype, 0, sizeof(ctype));
			memset(cencode, 0, sizeof(cencode));
			prevheader=NULL;
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (is_msg_end(inbuffer)) return 0;
				if ((depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return 0;
				if (strcmp(inbuffer, "")==0) {
					head=0;
					break;
				}
				if (strncasecmp(inbuffer, boundary, strlen(boundary))==0) {
					memset(cfile, 0, sizeof(cfile));
					memset(cdisp, 0, sizeof(cdisp));
					memset(ctype, 0, sizeof(ctype));
					memset(cencode, 0, sizeof(cencode));
					prevheader=NULL;
					continue;
				}
				if (strncasecmp(inbuffer, "Content-Transfer-Encoding:", 26)==0) {
					ptemp=inbuffer+26;
					while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
					strncpy(cencode, ptemp, sizeof(cencode)-1);
					if ((strncasecmp(cencode, "base64", 6)!=0)&&(strncasecmp(cencode, "quoted-printable", 16)!=0)&&
					    (strncasecmp(cencode, "7bit", 4)!=0)&&(strncasecmp(cencode, "8bit", 4)!=0)) {
						memset(cencode, 0, sizeof(cencode));
						memset(cfile, 0, sizeof(cfile));
						continue;
					}
				}
				if (strncasecmp(inbuffer, "Content-Type:", 13)==0) {
					prevheader=ctype;
					prevheadersize=sizeof(ctype);
					ptemp=inbuffer+13;
					while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
					strncat(prevheader, ptemp, prevheadersize-strlen(prevheader)-1);
				} else if (strncasecmp(inbuffer, "Content-Disposition:", 20)==0) {
					prevheader=cdisp;
					prevheadersize=sizeof(cdisp);
					ptemp=inbuffer+20;
					while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
					strncat(prevheader, ptemp, prevheadersize-strlen(prevheader)-1);
				} else if ((inbuffer[0]==' ')||(inbuffer[0]=='\t')) {
					if (prevheader!=NULL) strncat(prevheader, inbuffer, prevheadersize-strlen(prevheader)-1);
				} else {
					prevheader=NULL;
					prevheadersize=0;
				}
				if (strlen(cfile)==0) {
					if ((ptemp=strcasestr(ctype, "name="))==NULL) {
						if ((ptemp=strcasestr(cdisp, "name="))==NULL) {
							continue;
						}
					}
					ptemp+=5;
					if (*ptemp=='\"') ptemp++;
					memset(fnamebuf, 0, sizeof(fnamebuf));
					while ((*ptemp)&&(*ptemp!='\"')&&(strlen(fnamebuf)<sizeof(fnamebuf)-1)) {
						fnamebuf[strlen(fnamebuf)]=*ptemp;
						ptemp++;
					}
					snprintf(cfile, sizeof(cfile)-1, "%s", DecodeRFC2047(fnamebuf));
					if (strcmp(cfile, filename)!=0) {
						memset(cfile, 0, sizeof(cfile));
						memset(cdisp, 0, sizeof(cdisp));
						memset(ctype, 0, sizeof(ctype));
						memset(cencode, 0, sizeof(cencode));
						prevheader=NULL;
						continue;
					}
				}
				if ((strlen(cfile)>0)&&(strcmp(inbuffer, "")==0)) break;
				if (strlen(cencode)==0) {
					snprintf(cencode, sizeof(cencode)-1, "8bit");
				}
			}
		}
		if ((ptemp=strcasestr(ctype, "boundary="))!=NULL) {
			ptemp+=9;
			if (*ptemp=='\"') ptemp++;
			snprintf(cbound, sizeof(cbound)-1, "--");
			while ((*ptemp)&&(*ptemp!='\"')&&(strlen(cbound)<sizeof(cbound)-1)) {
				cbound[strlen(cbound)]=*ptemp;
				ptemp++;
			}
		}
		if (strcasestr(ctype, "multipart")!=NULL) {
			if (webmailfiledl_r(cbound, filename, depth)==1) {
				return 1;
			} else {
				head=1;
				continue;
			}
		}
		if (is_msg_end(inbuffer)) break;
		if ((strlen(cencode))&&(strlen(cfile))) {
			ptemp=get_mime_type(cfile);
			printf("Content-Disposition: attachment\r\n");
			send_header(1, "1", ptemp, -1, -1);
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (is_msg_end(inbuffer)) return 1;
				if (strncasecmp(inbuffer, boundary, strlen(boundary))==0) break;
				if (strncasecmp(cencode, "base64", 6)==0) {
					DecodeBase64(inbuffer, "");
				} else if (strncasecmp(cencode, "quoted-printable", 16)==0) {
					DecodeQP(0, inbuffer, "");
				} else if (strncasecmp(cencode, "7bit", 4)==0) {
					DecodeText(0, inbuffer);
				} else if (strncasecmp(cencode, "8bit", 4)==0) {
					DecodeText(0, inbuffer);
				}
			}
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (is_msg_end(inbuffer)) return 1;
			}
		} else {
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (is_msg_end(inbuffer)) break;
				if (strcmp(inbuffer, "")==0) {
					break;
				}
				if (strcasestr(inbuffer, boundary)!=NULL) {
					head=1;
					break;
				}
			}
		}
	}
	return 0;
}

void webmailfiledl()
{
	wmheader header;
	char *pQueryString;
	char filename[512];
	char inbuffer[1024];
	char msgtype[100];
	int nummessages;
	int nummessage=0;

	memset(filename, 0, sizeof(filename));
	pQueryString=strstr(request.RequestURI, "/mailfile/");
	if (pQueryString==NULL) {
		send_header(0, "1", "text/html", -1, -1);
		printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=%s/mailread?msg=%d\">\n", request.ScriptName, nummessage);
		printf("%s", ERR_BADURI);
		wmexit();
	}
	pQueryString+=10;
	nummessage=atoi(pQueryString);
	while ((isdigit(*pQueryString)!=0)&&(*pQueryString!=0)) pQueryString++;
	while (*pQueryString=='/') pQueryString++;
	strncpy(filename, pQueryString, sizeof(filename)-1);
	URLDecode(filename);
	if ((nummessage<1)||(strlen(filename)<1)) {
		send_header(0, "1", "text/html", -1, -1);
		printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=%s/mailread?msg=%d\">\n", request.ScriptName, nummessage);
		printf("<CENTER>%s</CENTER><BR>\n", ERR_INVALIDURI);
		wmexit();
	}
	if (wmserver_connect()!=0) return;
	nummessages=wmserver_count();
	if (nummessages<nummessage) {
		send_header(0, "1", "text/html", -1, -1);
		printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=%s/mailread?msg=%d\">\n", request.ScriptName, nummessage);
		printf("<CENTER>%s</CENTER><BR>\n", ERR_NOMESSAGE);
		wmserver_disconnect();
		return;
	}
	wmserver_msgretr(nummessage);
	memset((char *)&header, 0, sizeof(header));
	memset(msgtype, 0, sizeof(msgtype));
	if (webmailheader(&header)!=0) return;
	if (strcasestr(header.contenttype, "multipart")==NULL) {
		for (;;) {
			wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
			if (is_msg_end(inbuffer)) break;
		}
		send_header(0, "1", "text/html", -1, -1);
		printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=%s/mailread?msg=%d\">\n", request.ScriptName, nummessage);
		printf("<CENTER>%s</CENTER><BR>\n", ERR_NOFILES);
		wmserver_disconnect();
		return;
	}
	if (webmailfiledl_r(header.boundary, filename, 0)==0) {
		send_header(0, "1", "text/html", -1, -1);
		printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=%s/mailread?msg=%d\">\n", request.ScriptName, nummessage);
		printf("<CENTER>%s</CENTER><BR>\n", ERR_NOFILE);
	}
	wmserver_disconnect();
	return;
}

char *webmailfileul(char *xfilename, char *xfilesize)
{
	char *filebody=NULL;
	char lfilename[1024];
	int filesize=0;
	char line[1024];
	char location[1024];
	char boundary[1024];
	char boundary2[1024];
	char boundary3[1024];
	char *pPostData;
	char *ptemp;
	unsigned int i;
	unsigned int j;

	pPostData=request.PostData;
	memset(boundary, 0, sizeof(boundary));
	memset(location, 0, sizeof(location));
	i=0;
	j=0;
	/* duhh..  this should just retrieve the boundary from request.ContentType,
	 * and maybe check same to make sure this really is MIME, while it's at it.
	 */
	/* get the mime boundary */
	while ((*pPostData!='\r')&&(*pPostData!='\n')&&(i<request.ContentLength)&&(strlen(boundary)<sizeof(boundary)-1)) {
		boundary[j]=*pPostData;
		pPostData++;
		i++;
		j++;
	}
	/* eat newline garbage */
	while ((*pPostData=='\n')||(*pPostData=='\r')) {
		pPostData++;
		i++;
	}
	snprintf(boundary2, sizeof(boundary2)-1, "%s--", boundary);
	snprintf(boundary3, sizeof(boundary3)-1, "\r\n%s", boundary);
	pPostData=request.PostData;
	while ((strcmp(line, boundary2)!=0)&&(i<request.ContentLength)) {
		memset(line, 0, sizeof(line));
		j=0;
		while ((*pPostData!='\r')&&(*pPostData!='\n')&&(i<request.ContentLength)&&(strlen(line)<sizeof(line)-1)) {
			line[j]=*pPostData;
			pPostData++;
			i++;
			j++;
		}
		/* eat newline garbage */
		while ((*pPostData=='\n')||(*pPostData=='\r')) {
			pPostData++;
			i++;
		}
		ptemp=line;
		if (strncasecmp(line, "Content-Disposition: form-data; ", 32)!=0) continue;
		ptemp+=32;
		if (strncasecmp(ptemp, "name=\"fattach\"; ", 16)!=0) continue;
		ptemp+=16;
		if (strncasecmp(ptemp, "filename=\"", 10)!=0) continue;
		ptemp+=10;
		if (strrchr(ptemp, '\\')!=NULL) {
			ptemp=strrchr(ptemp, '\\')+1;
		}
		snprintf(lfilename, sizeof(lfilename)-1, "%s", ptemp);
		while (lfilename[strlen(lfilename)-1]=='\"') lfilename[strlen(lfilename)-1]='\0';
		while ((strncmp(pPostData, "\r\n\r\n", 4)!=0)&&(strncmp(pPostData, "\n\n", 2)!=0)&&(i<request.ContentLength)) {
			pPostData++;
			i++;
		}
		if (strncmp(pPostData, "\r\n\r\n", 4)==0) {
			pPostData+=4;
			i+=4;
		} else if (strncmp(pPostData, "\n\n", 2)==0) {
			pPostData+=2;
			i+=2;
		} else {
			continue;
		}
		snprintf(xfilename, 1024, "%s", lfilename);
		filebody=pPostData;
		filesize=0;
		while ((strncmp(pPostData, boundary3, strlen(boundary3))!=0)&&(i<request.ContentLength)) {
			pPostData++;
			filesize++;
		}
	}
	snprintf(xfilesize, 9, "%d", filesize);
	return filebody;
}

int webmailmime(char *contenttype, char *encoding, char *boundary, short int nummessage, short int reply, short int depth)
{
	static char inbuffer[1024];
	char cencode[100];
	char ctype[200];
	char cbound[100];
	char tbound[100];
	char *ptemp;
	int file=0;
	int head=0;
	int msgdone=0;
	int i;

	if (depth==0) {
		memset(filename, 0, sizeof(filename));
		numfiles=0;
	}
	depth++;
	if ((strcasestr(contenttype, "multipart")==NULL)&&(strcasestr(contenttype, "message/rfc822")==NULL)) {
		if ((!reply)&&(strncasecmp(contenttype, "text/html", 9)!=0)) {
			printf("<PRE><FONT FACE=Arial, Verdana>");
		}
		for (;;) {
			wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
			if (is_msg_end(inbuffer)) break;
			if (strncasecmp(encoding, "quoted-printable", 16)==0) {
				DecodeQP(reply, inbuffer, contenttype);
			} else if (strncasecmp(encoding, "base64", 6)==0) {
				DecodeBase64(inbuffer, contenttype);
			} else if (strncasecmp(contenttype, "text/html", 9)==0) {
				DecodeHTML(reply, inbuffer, contenttype, 1);
			} else {
				printline(reply, inbuffer);
			}
		}
		if ((!reply)&&(strncasecmp(contenttype, "text/html", 9)!=0)) {
			printf("</FONT></PRE>\n");
		}
		return 1;
	}
	if (strncasecmp(contenttype, "message/rfc822", 14)==0) {
		head=1;
	} else {
		for (;;) {
			wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
			if (is_msg_end(inbuffer)) break;
			if (strcasestr(inbuffer, boundary)!=NULL) {
				head=1;
				break;
			}
		}
	}
	memset(cbound, 0, sizeof(cbound));
	memset(tbound, 0, sizeof(tbound));
	snprintf(tbound, sizeof(tbound)-1, "%s--", boundary);
	for (;;) {
		if (is_msg_end(inbuffer)) break;
		if ((strcasestr(contenttype, "multipart")!=NULL)||(strcasestr(contenttype, "message")!=NULL)) {
			if ((depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return msgdone;
		}
		if (head) {
			memset(ctype, 0, sizeof(ctype));
			memset(cencode, 0, sizeof(cencode));
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (is_msg_end(inbuffer)) break;
				if ((strcasestr(contenttype, "multipart")!=NULL)||(strcasestr(contenttype, "message")!=NULL)) {
					if ((depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return msgdone;
				}
				if (strcmp(inbuffer, "")==0) {
					head=0;
					break;
				}
				if (strncasecmp(inbuffer, "Content-Transfer-Encoding:", 26)==0) {
					ptemp=inbuffer+26;
					while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
					strncpy(cencode, ptemp, sizeof(cencode)-1);
				}
				if (strncasecmp(inbuffer, "Content-Type:", 13)==0) {
					ptemp=inbuffer+13;
					while ((*ptemp==' ')||(*ptemp=='\t')) ptemp++;
					strncpy(ctype, ptemp, sizeof(ctype)-1);
					while (inbuffer[strlen(inbuffer)-1]==';') {
						wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
						striprn(inbuffer);
						strncat(ctype, inbuffer, sizeof(ctype)-strlen(ctype)-1);
					}
				}
				if ((strcasestr(contenttype, "multipart")==NULL)&&(strcasestr(contenttype, "message")==NULL)) continue;
				if (file) continue;
				ptemp=strcasestr(inbuffer, "name=");
				if (ptemp!=NULL) {
					ptemp+=5;
					if (*ptemp=='\"') ptemp++;
					while ((*ptemp)&&(*ptemp!='\"')&&(strlen(filename[numfiles])<sizeof(filename[numfiles])-1)) {
						filename[numfiles][strlen(filename[numfiles])]=*ptemp;
						ptemp++;
					}
					file=1;
					numfiles++;
				}
			}
		}
		if (strncasecmp(ctype, "message/rfc822", 14)==0) {
			if (!reply) printf("<HR>");
			webmailmime(ctype, cencode, boundary, nummessage, reply, depth);
			head=1;
			continue;
		}
		if ((ptemp=strcasestr(ctype, "boundary="))!=NULL) {
			ptemp+=9;
			if (*ptemp=='\"') ptemp++;
			snprintf(cbound, sizeof(cbound)-1, "--");
			while ((*ptemp)&&(*ptemp!='\"')&&(strlen(cbound)<sizeof(cbound)-1)) {
				cbound[strlen(cbound)]=*ptemp;
				ptemp++;
			}
		}
		if (strcasestr(ctype, "multipart")!=NULL) {
			msgdone=webmailmime(ctype, cencode, cbound, nummessage, reply, depth);
			head=1;
			continue;
		}
		if (is_msg_end(inbuffer)) break;
		if (file) {
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (is_msg_end(inbuffer)) break;
				if ((strcasestr(contenttype, "multipart")!=NULL)||(strcasestr(contenttype, "message")!=NULL)) {
					if ((depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return msgdone;
				}
				if (strcmp(inbuffer, "")==0) {
					file=0;
					break;
				}
				if (strcasestr(inbuffer, boundary)!=NULL) {
					file=0;
					head=1;
					break;
				}
			}
		}
		if (is_msg_end(inbuffer)) break;
		if (head) continue;
		// start reading the part body
		for (;;) {
			if (strcmp(inbuffer, "")==0) break;
			wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
			if (is_msg_end(inbuffer)) break;
			if ((strcasestr(contenttype, "multipart")!=NULL)&&(depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return msgdone;
		}
		if (is_msg_end(inbuffer)) break;
		if (!reply) {
			if (strncasecmp(contenttype, "multipart/report", 16)==0) {
				printf("<HR>\n");
			}
			if ((!msgdone)&&(strncasecmp(ctype, "text/html", 9)!=0)) {
				printf("<PRE><FONT FACE=Arial, Verdana>");
			} else if (strncasecmp(ctype, "message", 7)==0) {
				printf("<PRE><FONT FACE=Arial, Verdana>");
			}
		}
		for (;;) {
			wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
			if (is_msg_end(inbuffer)) break;
			if ((strcasestr(contenttype, "multipart")!=NULL)&&(depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) break;
			if (strcasestr(inbuffer, boundary)!=NULL) {
				head=1;
				break;
			}
			if ((strncasecmp(contenttype, "multipart/report", 16)!=0)&&(strncasecmp(contenttype, "message/rfc822", 14)!=0)) {
				if (msgdone) continue;
			}
			if ((strncasecmp(ctype, "text/html", 9)!=0)&&(strncasecmp(ctype, "text/plain", 10)!=0)) {
				if (reply) continue;
			}
			if (strncasecmp(ctype, "text/html", 9)==0) {
				if (strncasecmp(cencode, "quoted-printable", 16)==0) {
					DecodeQP(reply, inbuffer, ctype);
				} else if (strncasecmp(cencode, "base64", 6)==0) {
					DecodeBase64(inbuffer, ctype);
				} else {
					DecodeHTML(reply, inbuffer, ctype, 1);
				}
			} else if (strncasecmp(contenttype, "multipart/alternative", 21)!=0) {
				if (strncasecmp(cencode, "quoted-printable", 16)==0) {
					DecodeQP(reply, inbuffer, ctype);
				} else if (strncasecmp(cencode, "base64", 6)==0) {
					DecodeBase64(inbuffer, ctype);
				} else {
					printline(reply, inbuffer);
				}
			}
		}
		if (!reply) {
			if ((!msgdone)&&(strncasecmp(ctype, "text/html", 9)!=0)) {
				printf("</FONT></PRE>\n");
			} else if (strncasecmp(ctype, "message", 7)==0) {
				printf("</FONT></PRE>\n");
			}
		}
		if (strncasecmp(ctype, "text/html", 9)==0) msgdone=1;
		if ((strncasecmp(ctype, "text/plain", 10)==0)&&(strncasecmp(contenttype, "multipart/alternative", 21)!=0)) {
			msgdone=1;
		}
		if (is_msg_end(inbuffer)) break;
		if ((strcasestr(contenttype, "multipart")!=NULL)&&(depth>1)&&(strcasestr(inbuffer, tbound)!=NULL)) return msgdone;
	}
	if ((!reply)&&(numfiles>0)) {
		printf("<HR>%s<BR>\n", NWM_ATTACHMENTS);
		for (i=0;i<numfiles;i++) {
			printf("[<A HREF=%s/mailfile/%d/", request.ScriptName, nummessage);
			printhex("%s", DecodeRFC2047(filename[i]));
			ptemp=get_mime_type(filename[i]);
			if (strncasecmp(ptemp, "image/", 6)==0) {
				printf(" TARGET=_blank");
			}
			printf(">");
			printht("%s", DecodeRFC2047(filename[i]));
			printf("</A>]<BR>\n");
		}
	}
	return msgdone;
}
