/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

void sig_timeout()
{
	send_header(0, "1", "text/html", -1, -1);
	printf("<B>Connection timed out.</B>\n");
#ifndef WIN32
	if (config.use_syslog=='y') {
		closelog();
	}
#endif
	exit(0);
}

void sig_catchint(int sig)
{
	send_header(0, "1", "text/html", -1, -1);
	printf("<B>Caught unhandled signal %d.</B>\n", sig);
#ifndef WIN32
	if (config.use_syslog=='y') {
		closelog();
	}
#endif
	exit(0);
}

void setsigs()
{
	short int i;
#ifdef _NSIG
	short int numsigs=_NSIG;
#else
	short int numsigs=NSIG;
#endif

	if (numsigs>16) numsigs=16;
	for(i=0;i<numsigs;i++) {
		signal(i, sig_catchint);
	}
#ifdef WIN32
	SetErrorMode(SEM_FAILCRITICALERRORS|SEM_NOGPFAULTERRORBOX|SEM_NOOPENFILEERRORBOX);
#else
	signal(SIGALRM, sig_timeout);
	alarm(config.max_runtime);
#endif
}
