/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

void webmaildelete()
{
	char msgnum[8];
	char uidl[100];
	int nummessages;
	int deleted=0;
	int i;

	printheader();
	if (wmserver_connect()!=0) return;
	nummessages=wmserver_count();
	if (nummessages>0) {
		for (i=nummessages;i>0;i--) {
			snprintf(msgnum, sizeof(msgnum)-1, "%d", i);
			if ((getpostenv(msgnum)==NULL)&&(getgetenv(msgnum)==NULL)) continue;
			memset(uidl, 0, sizeof(uidl));
			wmserver_uidl(i, uidl);
			if ((getpostenv(msgnum)!=NULL)&&(strcmp(getpostenv(msgnum), uidl)!=0)) continue;
			if ((getgetenv(msgnum)!=NULL)&&(strcmp(getgetenv(msgnum), uidl)!=0)) continue;
			printf(NWM_DELETING, i);
			deleted=i;
			if (wmserver_msgdele(i)==0) {
				printf("%s<BR>\n", NWM_DELETE_OK);
			} else {
				printf("%s<BR>\n", NWM_DELETE_BAD);
			}
			fflush(stdout);
		}
	} else {
		printf("<CENTER>%s</CENTER><BR>\n", NWM_NOMAIL);
	}
	wmserver_disconnect();
	snprintf(msgnum, sizeof(msgnum)-1, "%d", deleted);
	if (deleted>=nummessages) deleted=nummessages-1;
	printf("<SCRIPT LANGUAGE=JavaScript>\n<!--\n");
	printf("location.replace(\"");
	if ((getgetenv(msgnum)==NULL)||(nummessages<2)) {
		printf("%s/maillist\");\n", request.ScriptName);
	} else {
		printf("%s/mailread?msg=%d\");\n", request.ScriptName, deleted);
	}
	printf("// -->\n</SCRIPT>\n");
	printf("<NOSCRIPT>\n");
	printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; ");
	if ((getgetenv(msgnum)==NULL)||(nummessages<2)) {
		printf("URL=%s/maillist\">\n", request.ScriptName);
	} else {
		printf("URL=%s/mailread?msg=%d\">\n", request.ScriptName, deleted);
	}
	printf("</NOSCRIPT>\n");
	printfooter();
	return;
}

void webmaillist()
{
	wmheader header;
	char *ptemp;
	char inbuffer[1024];
	char msgsize[20];
	char uidl[100];
	signed char bgtoggle=0;
	int msize;
	int nummessages;
	int offset=0;
	int i;

	printheader();
	if (wmserver_connect()!=0) return;
	nummessages=wmserver_count();
	if (nummessages<1) {
		printf("<CENTER>%s</CENTER><BR>\n", NWM_NOMAIL);
		printfooter();
		wmserver_disconnect();
		return;
	}
	if ((ptemp=getgetenv("OFFSET"))!=NULL) offset=atoi(ptemp);
	if (offset<0) offset=0;
	i=nummessages-offset-config.max_list_size+1;
	if (i<1) i=1;
	printf("<script language='JavaScript'>\n<!--\n");
	printf("function CheckAll()\n{\n");
	printf("	for (var i=0;i<document.webmail.elements.length;i++) {\n");
	printf("		var e=document.webmail.elements[i];\n");
	printf("		if (e.name!='allbox') {\n");
	printf("			e.checked=document.webmail.allbox.checked;\n");
	printf("		}\n");
	printf("	}\n");
	printf("}\n//-->\n</script>\n");
	printf("<CENTER>\n");
	printf("<FORM METHOD=POST NAME=webmail ACTION=%s/maildelete>\n", request.ScriptName);
	printf("<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%%>\n");
	printf("<TR><TD ALIGN=LEFT NOWRAP WIDTH=150><INPUT TYPE=SUBMIT VALUE=\"%s\"></TD>\n", NWM_DELSELECTED);
	printf("<TD ALIGN=CENTER NOWRAP>");
	if (nummessages>config.max_list_size) {
		if (offset>0) {
			printf("[<A HREF=%s/maillist?offset=%d>%s</A>]\n", request.ScriptName, offset-config.max_list_size, NWM_PREVIOUS);
		} else {
			printf("[%s]\n", NWM_PREVIOUS);
		}
		if (offset+config.max_list_size<nummessages) {
			printf("[<A HREF=%s/maillist?offset=%d>%s</A>]\n", request.ScriptName, offset+config.max_list_size, NWM_NEXT);
		} else {
			printf("[%s]\n", NWM_NEXT);
		}
	} else {
		printf("&nbsp;");
	}
	printf("</TD><TD ALIGN=RIGHT NOWRAP>");
	printf(NWM_LISTCOUNT, nummessages-offset, i, nummessages);
	printf("</TD></TR>\n<TR><TD COLSPAN=3>\n");
	printf("<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1 WIDTH=100%%>\n");
	printf("<TR BGCOLOR=%s>\n", config.colour_trim);
	printf("<TH ALIGN=LEFT>&nbsp;</TH>");
	printf("<TH ALIGN=LEFT><FONT COLOR=%s>%s</FONT></TH>", config.colour_trimtext, NWM_FROM);
	printf("<TH ALIGN=LEFT WIDTH=100%%><FONT COLOR=%s>%s</FONT></TH>", config.colour_trimtext, NWM_SUBJECT);
	printf("<TH ALIGN=LEFT><FONT COLOR=%s>%s</FONT></TH>", config.colour_trimtext, NWM_DATE);
	printf("<TH ALIGN=LEFT><FONT COLOR=%s>%s</FONT></TH>", config.colour_trimtext, NWM_SIZE);
	printf("<TH ALIGN=LEFT>&nbsp;</TH>");
	printf("</TR>\n");
	for (i=nummessages-offset-1;(i>-1)&&(i>nummessages-offset-config.max_list_size-1);i--) {
		if ((msize=wmserver_msgsize(i+1))<0) continue;
		if (msize>=1048576) {
			snprintf(msgsize, sizeof(msgsize)-1, "%1.1f M", (float)msize/1048576.0);
		} else {
			snprintf(msgsize, sizeof(msgsize)-1, "%1.1f K", (float)msize/1024.0);
		}
		memset(uidl, 0, sizeof(uidl));
		wmserver_uidl(i+1, uidl);
		wmserver_msghead(i+1);
		memset((char *)&header, 0, sizeof(header));
		if (webmailheader(&header)!=0) return;
		if (strncasecmp(wmservertype, "pop3", 4)==0) {
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (strcmp(inbuffer, ".")==0) break;
			}
		} else if (strncasecmp(wmservertype, "imap", 4)==0) {
			for (;;) {
				wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				if (isdigit(inbuffer[0])) break;
			}
		}
		if ((config.pop_status=='y')&&(header.status=='n')) {
			printf("<TR BGCOLOR=\"%s\">", config.colour_mlistnew);
		} else {
			if ((bgtoggle=abs(bgtoggle-1))==0) {
				printf("<TR BGCOLOR=\"%s\">", config.colour_mlisteven);
			} else {
				printf("<TR BGCOLOR=\"%s\">", config.colour_mlistodd);
			}
		}
		printf("<TD NOWRAP><INPUT TYPE=checkbox NAME=%d VALUE=\"%s\"></TD>", i+1, uidl);
		printf("<TD NOWRAP TITLE='%s'>", str2html(DecodeRFC2047(header.From)));
		if ((ptemp=strchr(header.From, '<'))!=NULL) *ptemp='\0';
		printf("%.28s&nbsp;</TD>", DecodeRFC2047(header.From));
		printf("<TD NOWRAP><A HREF=%s/mailread?msg=%d TITLE=\"%s\">", request.ScriptName, i+1, DecodeRFC2047(header.Subject));
		printf("%.45s</A>&nbsp;</TD>", DecodeRFC2047(header.Subject));
		printf("<TD ALIGN=RIGHT NOWRAP>%s&nbsp;</TD>", decodedate(header.Date));
		printf("<TD ALIGN=RIGHT NOWRAP>%s&nbsp;</TD>", msgsize);
		if (strcasestr(header.contenttype, "multipart/mixed")!=NULL) {
			printf("<TD><IMG BORDER=0 SRC=%spaperclip.png HEIGHT=16 WIDTH=11 ALT='%s'></TD>", config.base_image_url, NWM_FILE);
		} else {
			printf("<TD>&nbsp;</TD>");
		}
		printf("</TR>\n");
	}
	printf("</TABLE>\n</TD></TR>");
	printf("<TR><TD ALIGN=LEFT WIDTH=150>");
	printf("<INPUT TYPE=checkbox NAME=allbox onclick='CheckAll();'>");
	printf("<B><NOBR>%s</NOBR></B><BR>\n", NWM_SELECTALL);
	printf("<INPUT TYPE=SUBMIT VALUE=\"%s\"></TD>\n", NWM_DELSELECTED);
	printf("<TD ALIGN=CENTER VALIGN=TOP NOWRAP>");
	if (nummessages>config.max_list_size) {
		if (offset>0) {
			printf("[<A HREF=%s/maillist?offset=%d>%s</A>]\n", request.ScriptName, offset-config.max_list_size, NWM_PREVIOUS);
		} else {
			printf("[%s]\n", NWM_PREVIOUS);
		}
		if (offset+config.max_list_size<nummessages) {
			printf("[<A HREF=%s/maillist?offset=%d>%s</A>]\n", request.ScriptName, offset+config.max_list_size, NWM_NEXT);
		} else {
			printf("[%s]\n", NWM_NEXT);
		}
	} else {
		printf("&nbsp;");
	}
	printf("</TD><TD ALIGN=RIGHT VALIGN=TOP NOWRAP WIDTH=150>&nbsp;</TD></TR>\n");
	printf("</TABLE>\n");
	printf("</FORM>\n");
	printf("</CENTER>\n");
	printfooter();
	wmserver_disconnect();
	return;
}

void webmailraw()
{
	char inbuffer[1024];
	int nummessages;
	int nummessage;

	send_header(0, "1", "text/plain", -1, -1);
	if (wmserver_connect()!=0) return;
	nummessages=wmserver_count();
	nummessage=atoi(getgetenv("MSG"));
	if ((nummessage>nummessages)||(nummessage<1)) {
		printf("%s<BR>", ERR_NOMESSAGE);
		wmserver_disconnect();
		return;
	}
	wmserver_msgretr(nummessage);
	for (;;) {
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
		if (strcmp(inbuffer, "")==0) break;
		printf("%s\r\n", inbuffer);
	}
	printf("\r\n");
	for (;;) {
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
		if (is_msg_end(inbuffer)) break;
		printf("%s\r\n", inbuffer);
	}
	wmserver_disconnect();
	return;
}

void webmailread()
{
	wmheader header;
	char uidl[100];
	short int nummessages;
	short int nummessage;

	printheader();
	if (wmserver_connect()!=0) return;
	nummessages=wmserver_count();
	nummessage=atoi(getgetenv("MSG"));
	if ((nummessage>nummessages)||(nummessage<1)) {
		printf("%s<BR>", ERR_NOMESSAGE);
		wmserver_disconnect();
		return;
	}
	memset(uidl, 0, sizeof(uidl));
	wmserver_uidl(nummessage, uidl);
	printf("<SCRIPT LANGUAGE=JavaScript>\n<!--\n");
	printf("function ConfirmDelete() {\n");
	printf("	return confirm(\"%s\");\n", NWM_DELCONFIRM);
	printf("}\n");
	printf("// -->\n</SCRIPT>\n");
	printf("<CENTER>\n");
	if (nummessage>1) {
		printf("[<A HREF=%s/mailread?msg=%d>%s</A>]\n", request.ScriptName, nummessage-1, NWM_PREVIOUS);
	} else {
		printf("[%s]\n", NWM_PREVIOUS);
	}
	printf("[<A HREF=%s/mailwrite?replyto=%d>%s</A>]\n", request.ScriptName, nummessage, NWM_REPLY);
	printf("[<A HREF=%s/mailwrite?replyall=%d>Reply All</A>]\n", request.ScriptName, nummessage);
	printf("[<A HREF=%s/mailwrite?forward=%d>%s</A>]\n", request.ScriptName, nummessage, NWM_FORWARD);
	printf("[<A HREF=%s/maildelete?%d=%s onClick=\"return ConfirmDelete();\">%s</A>]\n", request.ScriptName, nummessage, uidl, NWM_DELETE);
	if (nummessage<nummessages) {
		printf("[<A HREF=%s/mailread?msg=%d>%s</A>]\n", request.ScriptName, nummessage+1, NWM_NEXT);
	} else {
		printf("[%s]\n", NWM_NEXT);
	}
	printf("<BR><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=1 WIDTH=100%%>\n");
	wmserver_msgretr(nummessage);
	memset((char *)&header, 0, sizeof(header));
	if (webmailheader(&header)!=0) return;
	printf("<TR BGCOLOR=%s><TD><TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 WIDTH=100%%>\n", config.colour_ftext);
	printf("<TR><TH ALIGN=LEFT BGCOLOR=%s VALIGN=TOP><FONT COLOR=%s>&nbsp;%s&nbsp;&nbsp;</FONT></TH><TD BGCOLOR=%s WIDTH=100%%>&nbsp;<A HREF=%s/mailwrite?to=%s>", config.colour_trim, config.colour_trimtext, NWM_FROM, config.colour_ftext, request.ScriptName, header.ReplyTo);
	printht("%s", DecodeRFC2047(header.From));
	printf("</A>&nbsp;</TD></TR>\n");
	printf("<TR><TH ALIGN=LEFT BGCOLOR=%s VALIGN=TOP><FONT COLOR=%s>&nbsp;%s&nbsp;&nbsp;</FONT></TH><TD BGCOLOR=%s WIDTH=100%%>&nbsp;", config.colour_trim, config.colour_trimtext, NWM_TO, config.colour_ftext);
	printht("%s", DecodeRFC2047(header.To));
	printf("&nbsp;</TD></TR>\n");
	if (strlen(header.CC)) {
		printf("<TR><TH ALIGN=LEFT BGCOLOR=%s VALIGN=TOP><FONT COLOR=%s>&nbsp;%s&nbsp;&nbsp;</FONT></TH><TD BGCOLOR=%s WIDTH=100%%>&nbsp;", config.colour_trim, config.colour_trimtext, NWM_CC, config.colour_ftext);
		printht("%s", DecodeRFC2047(header.CC));
		printf("&nbsp;</TD></TR>\n");
	}
	printf("<TR><TH ALIGN=LEFT BGCOLOR=%s VALIGN=TOP><FONT COLOR=%s>&nbsp;%s&nbsp;&nbsp;</FONT></TH><TD BGCOLOR=%s WIDTH=100%%>&nbsp;", config.colour_trim, config.colour_trimtext, NWM_SUBJECT, config.colour_ftext);
	printht("%s", DecodeRFC2047(header.Subject));
	printf("&nbsp;</TD></TR>\n");
	printf("<TR><TH ALIGN=LEFT BGCOLOR=%s VALIGN=TOP><FONT COLOR=%s>&nbsp;%s&nbsp;&nbsp;</FONT></TH><TD BGCOLOR=%s WIDTH=100%%>&nbsp;", config.colour_trim, config.colour_trimtext, NWM_DATE, config.colour_ftext);
	printht("%s", header.Date);
	printf("&nbsp;</TD></TR>\n");
	printf("</TABLE></TD></TR>\n");
	if (config.raw_messages=='y') {
		printf("<TR BGCOLOR=%s><TD COLSPAN=2>[<A HREF=%s/mailraw?msg=%d TARGET=_blank>%s</A>]</TD></TR>\n", config.colour_ftext, request.ScriptName, nummessage, NWM_VIEW_SRC);
	}
	printf("<TR BGCOLOR=%s><TD>\n", config.colour_ftext);
	webmailmime(header.contenttype, header.encoding, header.boundary, nummessage, 0, 0);
	printf("</TD></TR></TABLE>\n");
	if (nummessage>1) {
		printf("[<A HREF=%s/mailread?msg=%d>%s</A>]\n", request.ScriptName, nummessage-1, NWM_PREVIOUS);
	} else {
		printf("[%s]\n", NWM_PREVIOUS);
	}
	printf("[<A HREF=%s/mailwrite?replyto=%d>%s</A>]\n", request.ScriptName, nummessage, NWM_REPLY);
	printf("[<A HREF=%s/mailwrite?replyall=%d>Reply All</A>]\n", request.ScriptName, nummessage);
	printf("[<A HREF=%s/mailwrite?forward=%d>%s</A>]\n", request.ScriptName, nummessage, NWM_FORWARD);
	printf("[<A HREF=%s/maildelete?%d=%s onClick=\"return ConfirmDelete();\">%s</A>]\n", request.ScriptName, nummessage, uidl, NWM_DELETE);
	if (nummessage<nummessages) {
		printf("[<A HREF=%s/mailread?msg=%d>%s</A>]\n", request.ScriptName, nummessage+1, NWM_NEXT);
	} else {
		printf("[%s]\n", NWM_NEXT);
	}
	printfooter();
	wmserver_disconnect();
	return;
}

void webmailsend()
{
	char *filebody=NULL;
	char *msgbody=NULL;
	char *pmsgbody;
	char *ptemp;
	char boundary[100];
	char inbuffer[1024];
	char outbuffer[1024];
	char filename[1024];
	char cfilesize[10];
	char msgaddr[128];
	char msgctype[16];
	char msgto[1024];
	char msgcc[1024];
	char msgbcc[1024];
	char msgsubject[128];
	char msgdate[100];
	char msgdatetz[100];
	char line[1024];
	int filesize=0;
	short int numrecipients=0;
#ifdef WIN32
	struct timeb tstruct;
#else
	struct timeval ttime;
	struct timezone tzone;
#endif
	time_t t;
	short int error=0;
	int i;

	t=time(NULL);
	memset(boundary, 0, sizeof(boundary));
	snprintf(boundary, sizeof(boundary)-1, "------------NWM%d", (int)t);
	if (strcasecmp(request.RequestMethod, "POST")!=0) return;
	memset(inbuffer, 0, sizeof(inbuffer));
	memset(outbuffer, 0, sizeof(outbuffer));
	printheader();
	memset(wmaddress, 0, sizeof(wmaddress));
	if (config.allow_userfrom=='y') {
		if ((ptemp=getmimeenv("FROM"))!=NULL) {
			strncpy(wmaddress, ptemp, sizeof(wmaddress)-1);
		}
	} else {
		if (config.use_append_address=='y') {
			snprintf(wmaddress, sizeof(wmaddress)-1, "\"%s\" <%s%s>", wmusername, wmusername, config.append_address);
		} else {
			snprintf(wmaddress, sizeof(wmaddress)-1, "\"%s\" <%s", wmusername, wmusername);
			if (strchr(wmusername, '@')==NULL) {
				unsigned int i, count;

				strncat(wmaddress, "@", sizeof(wmaddress)-strlen(wmaddress)-1);
				ptemp=wmpop3server;
				do {
					for (i=0, count=0;i<strlen(ptemp);i++) if (ptemp[i]=='.') count++;
					if (count>1) ptemp=strchr(ptemp, '.')+1;
				} while (count>1);
				strncat(wmaddress, ptemp, sizeof(wmaddress)-strlen(wmaddress)-1);
			}
			strncat(wmaddress, ">", sizeof(wmaddress)-strlen(wmaddress)-1);
		}
	}
	if (getmimeenv("TO")==NULL) {
		printf("<CENTER>%s</CENTER>\n", ERR_NORECIPIENT);
		error=1;
		goto quit;
	}
	memset(msgctype, 0, sizeof(msgctype));
	if ((ptemp=getmimeenv("CTYPE"))!=NULL) {
		snprintf(msgctype, sizeof(msgctype)-1, "text/%s", ptemp);
	} else {
		snprintf(msgctype, sizeof(msgctype)-1, "text/plain");
	}
	memset(msgto, 0, sizeof(msgto));
	memset(msgcc, 0, sizeof(msgcc));
	memset(msgbcc, 0, sizeof(msgbcc));
	memset(msgsubject, 0, sizeof(msgsubject));
	if (msgbody!=NULL) free(msgbody);
	msgbody=calloc(request.ContentLength+1024, sizeof(char));
	if ((ptemp=getmimeenv("TO"))!=NULL)  strncpy(msgto, ptemp, sizeof(msgto)-1);
	if ((ptemp=getmimeenv("CC"))!=NULL)  strncpy(msgcc, ptemp, sizeof(msgcc)-1);
	if ((ptemp=getmimeenv("BCC"))!=NULL) strncpy(msgbcc, ptemp, sizeof(msgbcc)-1);
	if ((ptemp=getmimeenv("SUBJECT"))!=NULL) strncpy(msgsubject, ptemp, sizeof(msgsubject)-1);
	if ((ptemp=getmimeenv("MSGBODY"))!=NULL) strncpy(msgbody, ptemp, request.ContentLength+1023);
	memset(filename, 0, sizeof(filename));
	memset(cfilesize, 0, sizeof(cfilesize));
	if (getmimeenv("FATTACH")!=NULL) {
		filebody=webmailfileul(filename, cfilesize);
		filesize=atoi(cfilesize);
		if (strlen(filename)==0) filesize=0;
	}
#ifdef WIN32
	ftime(&tstruct);
	strftime(msgdate, sizeof(msgdate), "%a, %d %b %Y %H:%M:%S", localtime(&tstruct.time));
	snprintf(msgdatetz, sizeof(msgdatetz)-1, " %+.4d", -tstruct.timezone/60*100);
	strncat(msgdate, msgdatetz, sizeof(msgdate)-strlen(msgdate)-1);
#else
	gettimeofday(&ttime, &tzone);
	strftime(msgdate, sizeof(msgdate), "%a, %d %b %Y %H:%M:%S", localtime(&ttime.tv_sec));
	snprintf(msgdatetz, sizeof(msgdatetz)-1, " %+.4d", -tzone.tz_minuteswest/60*100);
	strncat(msgdate, msgdatetz, sizeof(msgdate)-strlen(msgdate)-1);
#endif
	if ((strlen(wmusername)==0)||(strlen(wmpassword)==0)||(strlen(wmpop3server)==0)||(strlen(wmsmtpserver)==0)) {
		error=1;
		goto quit;
	}
	if (wmserver_smtpconnect()<0) {
		error=1;
		goto quit;
	}
	snprintf(outbuffer, sizeof(outbuffer)-1, "HELO %s\r\n", wmsmtpserver);
	wmprintf("%s", outbuffer);
	do {
		memset(inbuffer, 0, sizeof(inbuffer));
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
	} while ((inbuffer[3]!=' ')&&(inbuffer[3]!='\0'));
	if (strncasecmp(inbuffer, "250", 3)!=0) {error=1; goto quit; }
	if (config.smtp_auth=='y') {
		if (wmserver_smtpauth()!=0) {error=1; goto quit; }
	}
	ptemp=wmaddress;
	if (strchr(ptemp, '<')==NULL) {
		snprintf(outbuffer, sizeof(outbuffer)-1, "MAIL From: <%s>\r\n", ptemp);
		wmprintf("%s", outbuffer);
	} else {
		while ((*ptemp)&&(*ptemp!='<')) ptemp++;
		snprintf(outbuffer, sizeof(outbuffer)-1, "MAIL From: %s\r\n", ptemp);
		wmprintf("%s", outbuffer);
	}
	do {
		memset(inbuffer, 0, sizeof(inbuffer));
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
	} while ((inbuffer[3]!=' ')&&(inbuffer[3]!='\0'));
	if (strncasecmp(inbuffer, "250", 3)!=0) {error=1; goto quit; }
	printf(NWM_SMTP_FROMOK, str2html(ptemp));
	for (i=0;i<3;i++) {
		switch (i) {
			case 1: ptemp=msgcc; break;
			case 2: ptemp=msgbcc; break;
			default: ptemp=msgto; break;
		}
		while (*ptemp) {
			if (strstr(ptemp, "@")==NULL) break;
			memset(msgaddr, 0, sizeof(msgaddr));
			if (*ptemp==',') ptemp++;
			while ((*ptemp)&&(*ptemp!=',')) {
				if (strlen(msgaddr)>sizeof(msgaddr)-1) break;
				if (*ptemp=='\"') {
					ptemp++;
					while ((*ptemp)&&(*ptemp!='\"')) ptemp++;
					if (*ptemp=='\"') ptemp++;
				} else if (*ptemp==' ') {
					ptemp++;
				} else if (*ptemp=='<') {
					memset(msgaddr, 0, sizeof(msgaddr));
					ptemp++;
					do {
						if (strlen(msgaddr)<sizeof(msgaddr)-1) {
							msgaddr[strlen(msgaddr)]=*ptemp;
						}
						ptemp++;
					} while ((*ptemp)&&(*ptemp!='>'));
					if (*ptemp=='>') ptemp++;
				} else {
					if (strlen(msgaddr)<sizeof(msgaddr)-1) {
						msgaddr[strlen(msgaddr)]=*ptemp;
					}
					ptemp++;
				}
			}
			if (numrecipients<config.max_recipients) {
				snprintf(outbuffer, sizeof(outbuffer)-1, "RCPT To: <%s>\r\n", msgaddr);
				wmprintf("%s", outbuffer);
				do {
					memset(inbuffer, 0, sizeof(inbuffer));
					wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
				} while ((inbuffer[3]!=' ')&&(inbuffer[3]!='\0'));
				if (strncasecmp(inbuffer, "250", 3)!=0) {error=1; goto quit; }
				printf(NWM_SMTP_RCPTOK, msgaddr);
			}
			numrecipients++;
		}
	}
	snprintf(outbuffer, sizeof(outbuffer)-1, "DATA\r\n");
	wmprintf("%s", outbuffer);
	do {
		memset(inbuffer, 0, sizeof(inbuffer));
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
	} while ((inbuffer[3]!=' ')&&(inbuffer[3]!='\0'));
	if (strncasecmp(inbuffer, "354", 3)!=0) {error=1; goto quit; }
	ptemp=wmaddress;
	snprintf(outbuffer, sizeof(outbuffer)-1, "From: %s\r\n", ptemp);
	wmprintf("%s", outbuffer);
	ptemp=msgto;
	snprintf(outbuffer, sizeof(outbuffer)-1, "To: %s\r\n", msgto);
	wmprintf("%s", outbuffer);
	if (strlen(msgcc)) {
		wmprintf("Cc: %s\r\n", msgcc);
	}
	wmprintf("Subject: %s\r\n", msgsubject);
	wmprintf("Date: %s\r\n", msgdate);
	if (filesize>0) {
		wmprintf("MIME-Version: 1.0\r\n");
		wmprintf("Content-Type: multipart/mixed; boundary=\"%s\"\r\n", boundary);
	} else {
		wmprintf("Content-Type: %s; charset=%s\r\n", msgctype, MIME_CHARSET);
	}
	wmprintf("X-Mailer: %s\r\n", NWM_SERVERNAME);
	wmprintf("\r\n");
	pmsgbody=msgbody;
	if (filesize>0) {
		wmprintf("%s\r\n", NWM_MIME);
		wmprintf("--%s\r\n", boundary);
		wmprintf("Content-Type: %s; charset=%s\r\n", msgctype, MIME_CHARSET);
		wmprintf("Content-Transfer-Encoding: 8bit\r\n\r\n");
	}
	while (strlen(pmsgbody)>78) {
		memset(line, 0, sizeof(line));
		snprintf(line, 79, "%s", pmsgbody);
		line[78]='\0';
		if (strchr(line, '\r')||strchr(line, '\n')) {
			if ((ptemp=strchr(line, '\r'))!=NULL) *ptemp='\0';
			if ((ptemp=strchr(line, '\n'))!=NULL) *ptemp='\0';
			wmprintf("%s\r\n", line);
			pmsgbody+=strlen(line);
			if (*pmsgbody=='\r') pmsgbody++;
			if (*pmsgbody=='\n') pmsgbody++;
		} else if ((ptemp=strrchr(line, ' '))!=NULL) {
			*ptemp='\0';
			wmprintf("%s\r\n", line);
			pmsgbody+=strlen(line)+1;
		} else {
			wmprintf("%s", line);
			pmsgbody+=strlen(line);
		}
	}
	memset(line, 0, sizeof(line));
	snprintf(line, 78, "%s", pmsgbody);
	if (strlen(line)) wmprintf("%s\r\n", pmsgbody);
	free(msgbody);
	if (filesize>0) {
		printf(NWM_SENDINGFILE, filename, filesize);
		fflush(stdout);
		wmprintf("\r\n--%s\r\n", boundary);
		wmprintf("Content-Type: application/octet-stream; name=\"%s\"\r\n", filename);
		wmprintf("Content-Transfer-Encoding: base64\r\n");
		wmprintf("Content-Disposition: attachment; filename=\"%s\"\r\n\r\n", filename);
		EncodeBase64(filebody, filesize);
		wmprintf("\r\n--%s--\r\n", boundary);
	}
	snprintf(outbuffer, sizeof(outbuffer)-1, ".\r\n");
	wmprintf("%s", outbuffer);
	do {
		memset(inbuffer, 0, sizeof(inbuffer));
		wmfgets(inbuffer, sizeof(inbuffer)-1, wmsocket);
	} while ((inbuffer[3]!=' ')&&(inbuffer[3]!='\0'));
	if (strncasecmp(inbuffer, "250", 3)==0) {
		printf("<BR>%s<BR>\n", NWM_SMTP_SENT);
	}
	memset(outbuffer, 0, sizeof(outbuffer));
	memset(inbuffer, 0, sizeof(inbuffer));
	printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=%s/maillist\">\n", request.ScriptName);
quit:
	if (error) {
		if (strlen(outbuffer)) printf("%s<BR>\n", outbuffer);
		if (strlen(inbuffer)) printf("%s<BR>\n", inbuffer);
		webmailwrite();
	} else {
		printfooter();
	}
	wmserver_smtpdisconnect();
	return;
}

void webmailwrite()
{
	wmheader header;
	char *ptemp;
	char msgto[2048];
	char msgcc[2048];
	char msgbcc[2048];
	char subject[512];
	short int replyto=0;
	short int replyall=0;
	short int forward=0;
	short int msgnum;

	printheader();
	if (wmserver_connect()!=0) return;
	memset(msgto, 0, sizeof(msgto));
	memset(msgcc, 0, sizeof(msgcc));
	memset(msgbcc, 0, sizeof(msgbcc));
	memset(subject, 0, sizeof(subject));
	if (strcasecmp(request.RequestMethod, "POST")==0) {
		if ((ptemp=getmimeenv("TO"))!=NULL)      strncpy(msgto, ptemp, sizeof(msgto)-1);
		if ((ptemp=getmimeenv("CC"))!=NULL)      strncpy(msgcc, ptemp, sizeof(msgcc)-1);
		if ((ptemp=getmimeenv("BCC"))!=NULL)     strncpy(msgbcc, ptemp, sizeof(msgbcc)-1);
		if ((ptemp=getmimeenv("SUBJECT"))!=NULL) strncpy(subject, ptemp, sizeof(subject)-1);
	} else {
		if ((ptemp=getgetenv("REPLYTO"))!=NULL)  replyto=atoi(ptemp);
		if ((ptemp=getgetenv("REPLYALL"))!=NULL) { replyto=atoi(ptemp); replyall=1; }
		if ((ptemp=getgetenv("FORWARD"))!=NULL)  forward=atoi(ptemp);
		if ((ptemp=getgetenv("TO"))!=NULL)       strncpy(msgto, ptemp, sizeof(msgto)-1);
		if ((ptemp=getgetenv("CC"))!=NULL)       strncpy(msgcc, ptemp, sizeof(msgcc)-1);
		if ((ptemp=getgetenv("BCC"))!=NULL)      strncpy(msgbcc, ptemp, sizeof(msgbcc)-1);
	}
	if (replyto>0) {
		msgnum=replyto;
	} else if (forward>0) {
		msgnum=forward;
	} else {
		msgnum=0;
	}
	if (msgnum) {
		wmserver_msgretr(msgnum);
		memset((char *)&header, 0, sizeof(header));
		if (webmailheader(&header)!=0) return;
		if (replyto>0) {
			snprintf(subject, sizeof(subject)-1, "%s%s", (strncasecmp(DecodeRFC2047(header.Subject), "RE:", 3)==0)?"":"Re: ", DecodeRFC2047(header.Subject));
		} else if (forward>0) {
			snprintf(subject, sizeof(subject)-1, "%s%s", (strncasecmp(DecodeRFC2047(header.Subject), "FWD:", 4)==0)?"":"Fwd: ", DecodeRFC2047(header.Subject));
		}
		if (replyto>0) {
			snprintf(msgto, sizeof(msgto)-1, "%s", header.ReplyTo);
		}
		if (replyall) {
			strncpy(msgcc, header.CC, sizeof(msgcc)-strlen(msgcc)-1);
		}
	}
	memset(wmaddress, 0, sizeof(wmaddress));
	if (config.use_append_address=='y') {
		snprintf(wmaddress, sizeof(wmaddress)-1, "\"%s\" <%s%s>", wmusername, wmusername, config.append_address);
	} else {
		snprintf(wmaddress, sizeof(wmaddress)-1, "\"%s\" <%s", wmusername, wmusername);
		if (strchr(wmusername, '@')==NULL) {
			char *ptemp;
			unsigned int count, i;

			strncat(wmaddress, "@", sizeof(wmaddress)-strlen(wmaddress)-1);
			ptemp=wmpop3server;
			do {
				for (i=0, count=0;i<strlen(ptemp);i++) if (ptemp[i]=='.') count++;
				if (count>1) ptemp=strchr(ptemp, '.')+1;
			} while (count>1);
			strncat(wmaddress, ptemp, sizeof(wmaddress)-strlen(wmaddress)-1);
		}
		strncat(wmaddress, ">", sizeof(wmaddress)-strlen(wmaddress)-1);
	}
	printf("<script language=\"JavaScript\">\r\n<!--\r\n");
	printf("function selOn(ctrl)\r\n");
	printf("{\r\n");
	printf("	ctrl.style.borderColor='#000000';\r\n");
	printf("	ctrl.style.cursor='hand';\r\n");
	printf("}\r\n");
	printf("function selOff(ctrl)\r\n");
	printf("{\r\n");
	printf("	ctrl.style.borderColor='%s';\r\n", config.colour_editform);
	printf("}\r\n");
	printf("//-->\r\n</SCRIPT>\r\n");
	printf("<CENTER>\r\n");
	printf("<FORM METHOD=POST ACTION=%s/mailsend NAME=wmcompose ENCTYPE=multipart/form-data onSubmit=\"copy_submit()\">\n", request.ScriptName);
	printf("<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0>\n");
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;%s&nbsp;</B></TD><TD STYLE='padding:0px'><INPUT TYPE=TEXT NAME=from VALUE=\"%s\" SIZE=70%s></TD></TR>\n", config.colour_editform, NWM_FROM, str2html(wmaddress), config.allow_userfrom=='y'?"":" DISABLED");
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;%s&nbsp;</B></TD><TD STYLE='padding:0px'><INPUT TYPE=TEXT NAME=to VALUE=\"%s\" SIZE=70></TD></TR>\n", config.colour_editform, NWM_TO, str2html(msgto));
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;%s&nbsp;</B></TD><TD STYLE='padding:0px'><INPUT TYPE=TEXT NAME=cc VALUE=\"%s\" SIZE=70></TD></TR>\n", config.colour_editform, NWM_CC, str2html(msgcc));
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;%s&nbsp;</B></TD><TD STYLE='padding:0px'><INPUT TYPE=TEXT NAME=bcc VALUE=\"%s\" SIZE=70></TD></TR>\n", config.colour_editform, NWM_BCC, str2html(msgbcc));
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;%s&nbsp;</B></TD><TD STYLE='padding:0px'><INPUT TYPE=TEXT NAME=subject VALUE=\"%s\" SIZE=70></TD></TR>\n", config.colour_editform, NWM_SUBJECT, str2html(subject));
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;Format&nbsp;</B></TD><TD STYLE='padding:0px'>", config.colour_editform);
	printf("<select NAME=ctype onchange=toggle_mode()>\r\n<option value=plain>Plain Text</option>\r\n<option value=html>HTML</option>\r\n</select>\r\n");
	printf("</TD></TR>\r\n");
	printf("<TR BGCOLOR=%s><TD COLSPAN=2>", config.colour_editform);
	printf("<DIV ID=MenuBar STYLE='display: none'>\r\n");
	printf("<TABLE BORDER=0><TR><TD NOWRAP STYLE='padding:0px'>\r\n");
	printf("	<select onchange=\"SetFont('FontName', this.value)\">\r\n");
	printf("	<option value='Arial'>Arial</option>\r\n");
	printf("	<option value='Courier'>Courier</option>\r\n");
	printf("	<option value='Helvetica'>Helvetica</option>\r\n");
	printf("	<option value='Times New Roman' SELECTED>Times New Roman</option>\r\n");
	printf("	<option value='Verdana'>Verdana</option>\r\n");
	printf("	</select>\r\n");
	printf("	<select onchange=\"SetFont('FontSize', this.value)\">\r\n");
	printf("	<option value='1'>1</option>\r\n");
	printf("	<option value='2'>2</option>\r\n");
	printf("	<option value='3' SELECTED>3</option>\r\n");
	printf("	<option value='4'>4</option>\r\n");
	printf("	<option value='5'>5</option>\r\n");
	printf("	<option value='6'>6</option>\r\n");
	printf("	<option value='7'>7</option>\r\n");
	printf("	</select></TD><TD BGCOLOR=#000000 STYLE='padding:1px'></TD><TD STYLE='padding:0px'><IMG\r\n");
	printf("	ALT='Bold'                   SRC='%swmedit_bold.png'      onClick=wmformat('Bold')                 BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Italic'                 SRC='%swmedit_italic.png'    onClick=wmformat('Italic')               BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Underline'              SRC='%swmedit_underline.png' onClick=wmformat('Underline')            BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Font Colour'            SRC='%swmedit_fontcol.png'   onClick=SetForeColour()                  BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)></TD><TD BGCOLOR=#000000 STYLE='padding:1px'></TD><TD STYLE='padding:0px'><IMG\r\n", config.base_image_url);
	printf("	ALT='Formatting Numbers'     SRC='%swmedit_numlist.png'   onClick=wmformat('InsertOrderedList')    BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Formatting Bullets'     SRC='%swmedit_bullist.png'   onClick=wmformat('InsertUnorderedList')  BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Decrease Indentation'   SRC='%swmedit_outdent.png'   onClick=wmformat('Outdent')              BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Increase Indentation'   SRC='%swmedit_indent.png'    onClick=wmformat('Indent')               BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)></TD><TD BGCOLOR=#000000 STYLE='padding:1px'></TD><TD STYLE='padding:0px'><IMG\r\n", config.base_image_url);
	printf("	ALT='Align Left'             SRC='%swmedit_left.png'      onClick=wmformat('JustifyLeft')          BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Center'                 SRC='%swmedit_center.png'    onClick=wmformat('JustifyCenter')        BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Align Right'            SRC='%swmedit_right.png'     onClick=wmformat('JustifyRight')         BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Justify'                SRC='%swmedit_justify.png'   onClick=wmformat('Justify')              BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)></TD><TD BGCOLOR=#000000 STYLE='padding:1px'></TD><TD STYLE='padding:0px' width=100%%><IMG\r\n", config.base_image_url);
	printf("	ALT='Insert Horizontal Line' SRC='%swmedit_rule.png'      onClick=wmformat('InsertHorizontalRule') BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Create a Hyperlink'     SRC='%swmedit_link.png'      onClick=doLink()                         BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)><IMG\r\n", config.base_image_url);
	printf("	ALT='Insert Picture'         SRC='%swmedit_image.png'     onClick=doImage()                        BORDER=0 WIDTH=22 HEIGHT=22 CLASS=butClass onMouseOver=selOn(this) onMouseOut=selOff(this)></TD>\r\n", config.base_image_url);
	printf("</TR></TABLE>\r\n");
	printf("<IFRAME id=wmeditor HEIGHT=300 width=646></IFRAME>\r\n");
	printf("</DIV>\r\n");
	printf("<TEXTAREA NAME=msgbody COLS=78 ROWS=20 WRAP=VIRTUAL>\n");
	if (strcasecmp(request.RequestMethod, "POST")==0) {
		if ((ptemp=getmimeenv("MSGBODY"))!=NULL) printf("%s", ptemp);
	}
	if (msgnum) {
		printf(NWM_REPLYLINE, header.From);
		if (forward>0) {
			printf(NWM_FWD_FROM, header.From);
			printf(NWM_FWD_SUBJECT, header.Subject);
			printf(NWM_FWD_DATE, header.Date);
			printf(">\n");
		}
		webmailmime(header.contenttype, header.encoding, header.boundary, msgnum, 1, 0);
	}
	printf("</TEXTAREA>\n");
	printf("</TD></TR>\n");
	printf("<TR BGCOLOR=%s><TD STYLE='padding:0px'><B>&nbsp;%s&nbsp;</B></TD><TD STYLE='padding:0px'><INPUT TYPE=FILE NAME=fattach SIZE=60></TD></TR>\n", config.colour_editform, NWM_FILE);
	printf("</TABLE>\r\n");
	printf("<INPUT TYPE=SUBMIT VALUE='%s'>\r\n", NWM_SENDMAIL);
	printf("</FORM>\r\n</CENTER>\r\n");
	printf("<SCRIPT LANGUAGE=JavaScript SRC=%swmedit.js TYPE=text/javascript></SCRIPT>\r\n", config.base_image_url);
	printf("<script language=JavaScript>\r\n<!--\r\n");
	printf("	init();\r\n");
	printf("	document.wmcompose.to.focus();\r\n");
	printf("//-->\r\n</script>\r\n");
	printfooter();
	wmserver_disconnect();
	return;
}
